#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <string.h>
#include <linux/gpio.h>
#include <limits.h>

#include <pthread.h>


static void *busy_thread(void *argument) {

	while(1) {
		asm("");
	}

	return NULL;
}




int main(int argc, char **argv) {

	pthread_t *threads;
	int i,result;

	int max_count=10;

	if (argc>1) {
		max_count=atoi(argv[1]);
		printf("Setting busy threads to %d\n",max_count);
	}
	else {
		printf("busy threads is %d\n",max_count);
	}

	/* allocate the result arrays */
	threads=calloc(max_count,sizeof(pthread_t));
	if (threads==NULL) {
		fprintf(stderr,"Error allocating memory...\n");
		return -1;
	}

	for(i=0;i<max_count;i++) {
		/* start the writing thread */
		result = pthread_create(
                	&threads[i],
                	NULL,
                	busy_thread,
			NULL);
	}

	(void) result;

	/* wait for both threads to finish */
	for(i=0;i<max_count;i++) {
		pthread_join(threads[i],NULL);
	}
	return 0;
}
